# blog.privacynerd.de

This is my [blog](https://blog.privacynerd.de/), which is run by hugo. The repository contains the hugo sources of it.

## Cloning

To clone and make some changes, you need to clone the repository. This one also contains [git submodules](https://git-scm.com/book/en/v2/Git-Tools-Submodules) (the re-terminal theme), that's why you should use the argument `--recurse-submodules`. The commands after that pull all branches of the [forked terminal theme](https://github.com/BlueFox4/hugo-theme-terminal) so that nothing bad happens (commands taken from [here](https://stackoverflow.com/questions/10312521/how-do-i-fetch-all-git-branches).

```sh
git clone --recurse-submodules https://git.privacynerd.de/git.privacynerd.de/blog.privacynerd.de blog
cd blog/themes/terminal-fork
git branch -r \
  | grep -v '\->' \
  | sed "s,\x1B\[[0-9;]*[a-zA-Z],,g" \
  | while read remote; do \
      git branch --track "${remote#origin/}" "$remote"; \
    done
git fetch --all
git pull --all
cd ../../
```

## Running & Building

To build or run, just use one of the commands below. It will generate a new html in a fresh public folder.

> IMPORTANT! You have to be in the root of this repository to proceed. Executing one of the below commands will delete the `public` folder (to allow for a really fresh build).

```sh
rm -r public/ && hugo server --bind 127.0.0.1 -b http://127.0.0.1/ --minify --openBrowser --appendPort --printI18nWarnings
rm -r public/ && hugo build --minify --printI18nWarnings
```

## Acknowledgements

Favicon(s) generated by the [RealFaviconGenerator](https://realfavicongenerator.net/) out of my [original.png](static/original.png) (I drew this when I was a young child!).
