+++
title = 'Wie es alles anfing - oder: der erste Post!'
date = 2025-04-13T15:10:20+02:00
draft = false
toc = true
cover = '/files/how-it-all-began/cover.png'
+++


## Vorüberlegungen {id=thinking}

Ich habe lange überlegt, wie ich diesen Post schreibe. Was muss erzählt werden, was ist unwichtig? Vieles muss wegen der Übersichtlichkeit weggelassen werden, und an so manches erinnere ich mich vielleicht schon gar nicht mehr. Jedenfalls möchte ich mit diesem Artikel meine Intention erklären, wie ich dazu kam, diesen Blog zu starten. Doch um das zu erklären, muss man die Ursprünge verstehen.


## Wie alles anfing {id=beginnings}

Alles begann damit, dass ich als Schüler der 5. oder 6. Klasse (ich weiß es nicht mehr so genau!) anfing, auf einem Laptop für die Schule ein Batch-Skript zu schreiben. Ja, so war es, ich gebe es zu - auch wenn ich nicht weiß, wer oder was mich dazu trieb. Eine grobe Vorstellung habe ich aber: Ich glaube, es war so eine intrinsische Motivation eines Kindes, herauszufinden, wie dieser Computer da vor ihm funktioniert, die mich dazu trieb. 

Wie dem auch sei, eines meiner „Programme“ sah in etwa so aus:

```batch
@echo off

echo Herzlich Wilkommen , bitte Passwort eingeben
color 7b

:PSWD
set/p x=
if ''%x%''==''sehrsicher'' goto openfile

pause

:false 
echo Falsches Passwort , bitte erneut versuchen.
color 7c
goto PWSD

:openfile
echo Passwort richtig , bitte 'Enter' druecken!
goto Video

pause

:Video
echo Wenn sie sich ein Video anschauen moechten , dann geben sie jetzt ,,Ja`` ein , wenn nicht dann einfach ,,Nein''!
color 7b

:PSWD
set/p x=
if ''%x%''==''Ja'' goto OpenVideo

:false
goto exit

:OpenVideo 
start C:\Users\<ZENSIERT>\<JA WIRKLICH>\

:exit
exit
```

Nun ja, daraufhin schenkte mir mein Vater das Buch ein Lehrbuch zu Python3[^1], und es gab kein Zurück mehr. Ich glaube, ich habe mit meinen 11 oder 12 Jahren das gesamte Lehrbuch durchgelesen. Jedenfalls stieg ich irgendwann auf Linux um (anfangs [Linux Mint](https://linuxmint.com/)) - dann kam Corona[^2].


[^1]: [Python3 - das umfassende Handbuch von Johannes Ernesti und Peter Kaiser](https://www.rheinwerk-verlag.de/python-3-das-umfassende-handbuch/) (keine Werbung!)

[^2]: So einfach war es dann auch wieder nicht, aber aus Gründen der Übersichtlichkeit habe ich hier eben vereinfacht.

## Corona {id=covid-19}

Für Schüler bedeutete Corona und das damit einhergehende Homeschooling und die Isolation vor allem eins: viel Zeit. Man nutzte sie unterschiedlich. Ich eben dafür, meinem neuen Hobby intensiv nachzugehen. In dieser Zeit lernte ich neue Programmiersprachen wie Java (z.T. für Minecraft-Plugins, [hier](https://git.privacynerd.de/BlueFox/MC-Plugins) sind einige zu finden), brachte mir sogar etwas C und Assembler bei. 

In dieser Zeit bekam ich meinen ersten Raspberry Pi geschenkt - mit weitreichenden Folgen. Denn es führte dazu, dass ich mich mehr und mehr der Hardwareseite zuwandte. Hatte ich zuvor Webapps mit Datenbank in [Django](https://www.djangoproject.com/) bzw. [Flask](https://flask.palletsprojects.com/en/stable/) und Python geschrieben, programmierte ich jetzt einfache Blinkschaltungen, dann irgendwann Skripte, die Sensordaten auslesen und auf einem kleinen OLED-Display (0.96") anzeigen oder die Lampen in meinem Zimmer auf Knopfdruck an- und ausschalteten (weil ein Lichtschalter ja nicht genug ist!). Ich entdeckte in dieser Zeit auch einen 3D-Drucker für mich, der bei uns seit längerer Zeit fast unbenutzt herumstand.

{{< figure src="/files/how-it-all-began/esafep.png" alt="Bild des ESafeP - ein „Tresor“ aus Holz mit eigener Software" caption="Der „ESafeP“ - sehr stabil!" >}}

Noch hardwarenäher wurde es dann mit meinem ersten ESP32 - neue Ideen entstanden und damit neue Projekte. Ein selbstgebauter Tresor (supersicher aus Holz!) mit eigener [Software](https://git.privacynerd.de/BlueFox/ESafeP) gehörten ebenso dazu wie ein eigener [MP3-(und vieles mehr)-Player](https://git.privacynerd.de/NetSpeaker/NetSpeaker). Immer wieder kam dabei eben auch der 3D-Drucker zur Anwendung, wie es im DIY-Raum eben so üblich ist - zum Beispiel für das Gehäuse zu meinem batteriebetriebenen [Losungs-ePaper](https://git.privacynerd.de/BlueFox/losungepaper).


{{< figure src="/files/how-it-all-began/netspeaker.jpg" alt="Bild eines fertigen, selbstgebauten NetSpeakers in Gehäuse - unter anderem ein MP3-Player." caption="Ein NetSpeaker" >}}

{{< figure src="/files/how-it-all-began/losung-epaper.jpg" alt="Bild des fertigen ePapers, welches die aktuelle Tageslosung anzeigt" caption="Das Losungs-ePaper" >}}

Alles in allem hatte die Corona-Pandemie dadurch zumindest für mich vorher ungeahnte neue Räume eröffnet und eben auch ihre positiven Seiten: In dieser Zeit entwickelte sich mein Interesse am 3D-Druck, was auch in diesem Blog thematisiert werden könnte.


## Bis jetzt... {id=until-now}

Nun, sehr viel hat sich seither nicht mehr geändert. Irgendwann kam dann noch das Self-Hosting dazu, und ich lernte auch Holz als spannendes Werksmaterial kennen (wie etwas weiter oben schon angerissen). Es ist so spannend zu sehen, was man alles selber hosten kann: seinen eigenen Datei-Synchronisationsservice, sein [eigenes Github](https://git.privacynerd.de/), Medienserver, und so weiter. Anfangs lief alles auf dem besagten Raspberry Pi. Später musste jedoch auch Zugang von außerhalb des Heimnetzes her, und seither laufen viele Dienste auf einem angemieteten Server.

{{< figure src="/files/how-it-all-began/gitea-a-self-hosted-github.png" alt="Screenshot meiner selbstgehosteten Gitea-Instanz" caption="„Ein selbst gehostetes Github“" >}}

Vor nicht allzu langer Zeit kam mir dann eine Idee. Ich war dabei, selbst Platinen ätzen zu lernen, und die Informationen hierzu bezog ich vor allem in Blogs anderer „Maker”. Warum also nicht darüber, was du machst, schreiben? Zum einen könnte es ja tatsächlich sein, dass sich ein Suchender auf den Blog verirrt, zum anderen ist es aber auch einfach eine sinnvolle Dokumentationsweise, und vielleicht sogar etwas Gutes für spätere Bewerbungen.

{{< figure src="/files/how-it-all-began/etching-station.jpg" alt="Bild eines Aufbaus, um Platinen manuell zu ätzen; im Bild: ein selbst gebauter UV-Belichter, ein Ätzgerät sowie ein Gefäß mit Natronlauge" caption="Der Ätzaufbau" >}}

Also, hingesetzt und nach Möglichkeiten gesucht, einen Blog zu erstellen. Natürlich musste er selbst gehostet sein, und vielleicht sogar ein bisschen selbst gemacht. Das führte mich zu [Hugo](https://gohugo.io/) (auch Jekyll war eine Überlegung), einem relativ simplen (und sehr schnellen) Static-Site-Generator, der aus Markdown (unter anderem) Websites generieren kann und somit eigentlich perfekt für einen Blog geeignet ist. Bei der Theme-Auswahl schwankte ich anfangs zwischen „selbst erstellen“ und „vorhandenes nutzen“. Aus Zeitmangel und Gründen der Einfachheit wurde es dann eben ein vorhandenes, genauer [Terminal](https://themes.gohugo.io/themes/hugo-theme-terminal/). An meine Bedürfnisse angepasst, war der Blog an sich schon recht schnell fertig[^3]. Jetzt wartet er nur noch darauf, mit Inhalt gefüllt zu werden.

[^3]: ...einige Nachmittage (und Abende bis Nächte) gingen aber doch dafür drauf (um ehrlich zu sein).


## Geplante Inhalte {id=planned-content}

Was man am Anfang plant, wird selten genau so umgesetzt - und so wird es vermutlich auch mit diesem Blog sein, und das ist gut so. Schließlich entwickelt sich alles weiter. Aber ich schreibe hier jetzt dennoch auf, was ich plane, in Zukunft auf diesem Blog zu schreiben - eine grobe Vorstellung habe ich nämlich doch.

- über meine DIY-Projekte,
- über neue Erfahrungen, die ich beim Basteln sammle, 
- auch hier und da ein Update zu vorhandenen Projekten, Libraries,
- und vielleicht ja auch etwas ganz Neues!

Zusammengefasst: alles, was ich DIY-mäßig tue, möchte ich hier (wenn Zeit und Lust da sind) teilen bzw. dokumentieren - in der Hoffnung, dass sich vielleicht wirklich mal jemand die genau selbe Frage stellt wie ich oder eine ähnliche Idee hat wie ich, und sich dann in diesen Blog verirrt.
